// VolatileInteger.java
// Justin Ludiwg 1999.03.01

package edu.wooster.lu99jp26.util;

import java.lang.Integer;

public class VolatileInteger
{
	protected int value;
	
	/**
	 * creates new Integer with a value of zero
	 */
	public VolatileInteger ()
	{
		value = 0;
	}
	
	/**
	 * creates new Integer
	 * @param val Integer the initial value for this Integer
	 */
	public VolatileInteger (Integer val)
	{
		value = val.intValue ();
	}
	
	/**
	 * creates new Integer
	 * @param val int the initial value for this Integer
	 */
	public VolatileInteger (int val)
	{
		value = val;
	}
	
	/**
	 * gets this value in Integer form
	 * @return Integer the value
	 */
	public Integer get ()
	{
		return new Integer (value);
	}
	
	/**
	 * sets this value
	 * @param val Integer the new value
	 */
	public void set (Integer val)
	{
		value = val.intValue ();
	}
	
	/**
	 * gets this value in int form
	 * @return int the value
	 */
	public int getInt ()
	{
		return value;
	}
	
	/**
	 * sets this value
	 * @param val int the new value
	 */
	public void set (int val)
	{
		value = val;
	}
	
	/**
	 * increments this value
	 */
	public void increment ()
	{
		value++;
	}
	
	/**
	 * increments this value
	 * @param val int the increment
	 */
	public void increment (int val)
	{
		value += val;
	}
	
	/**
	 * increments this value
	 * @param val Integer the increment
	 */
	public void increment (Integer val)
	{
		value += val.intValue ();
	}
	
	/**
	 * decrements this value
	 */
	public void decrement ()
	{
		value--;
	}
	
	/**
	 * decrements this value
	 * @param val int the decrement
	 */
	public void decrement (int val)
	{
		value -= val;
	}
	
	/**
	 * decrements this value
	 * @param val Integer the decrement
	 */
	public void decrement (Integer val)
	{
		value -= val.intValue ();
	}
	
	/**
	 * compares this with o
	 * @param o Object
	 * @return boolean true if values are equal
	 */
	public boolean equals (Object o)
	{
		if (o instanceof VolatileInteger)
			return value == ((VolatileInteger) o).value;
		
		if (o instanceof Integer)
			return value == ((Integer) o).intValue ();
		
		return false;
	}
	
	/**
	 * compares this with val
	 * @param val int
	 * @return boolean true if values are equal
	 */
	public boolean equals (int val)
	{
		return value == val;
	}
}